<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_HotelRoom StructType
 * @subpackage Structs
 */
class JP_HotelRoom extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The RoomCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_RoomCategory
     */
    public $RoomCategory;
    /**
     * The RoomOccupancy
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_RoomOccupancy
     */
    public $RoomOccupancy;
    /**
     * The Rate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Rate
     */
    public $Rate;
    /**
     * The Images
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_ImageLong
     */
    public $Images;
    /**
     * The Size
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_HotelRoomSize
     */
    public $Size;
    /**
     * The Contracts
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_HotelRoomContract
     */
    public $Contracts;
    /**
     * The Features
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_Feature
     */
    public $Features;
    /**
     * The Units
     * @var int
     */
    public $Units;
    /**
     * The Source
     * @var string
     */
    public $Source;
    /**
     * The AvailRooms
     * @var int
     */
    public $AvailRooms;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * The JRCode
     * @var string
     */
    public $JRCode;
    /**
     * The CombinationCode
     * @var string
     */
    public $CombinationCode;
    /**
     * Constructor method for JP_HotelRoom
     * @uses JP_HotelRoom::setName()
     * @uses JP_HotelRoom::setDescription()
     * @uses JP_HotelRoom::setRoomCategory()
     * @uses JP_HotelRoom::setRoomOccupancy()
     * @uses JP_HotelRoom::setRate()
     * @uses JP_HotelRoom::setImages()
     * @uses JP_HotelRoom::setSize()
     * @uses JP_HotelRoom::setContracts()
     * @uses JP_HotelRoom::setFeatures()
     * @uses JP_HotelRoom::setUnits()
     * @uses JP_HotelRoom::setSource()
     * @uses JP_HotelRoom::setAvailRooms()
     * @uses JP_HotelRoom::setCode()
     * @uses JP_HotelRoom::setJRCode()
     * @uses JP_HotelRoom::setCombinationCode()
     * @param string $name
     * @param string $description
     * @param \StructType\JP_RoomCategory $roomCategory
     * @param \StructType\JP_RoomOccupancy $roomOccupancy
     * @param \StructType\JP_Rate $rate
     * @param \ArrayType\ArrayOfJP_ImageLong $images
     * @param \StructType\JP_HotelRoomSize $size
     * @param \ArrayType\ArrayOfJP_HotelRoomContract $contracts
     * @param \ArrayType\ArrayOfJP_Feature $features
     * @param int $units
     * @param string $source
     * @param int $availRooms
     * @param string $code
     * @param string $jRCode
     * @param string $combinationCode
     */
    public function __construct($name = null, $description = null, \StructType\JP_RoomCategory $roomCategory = null, \StructType\JP_RoomOccupancy $roomOccupancy = null, \StructType\JP_Rate $rate = null, \ArrayType\ArrayOfJP_ImageLong $images = null, \StructType\JP_HotelRoomSize $size = null, \ArrayType\ArrayOfJP_HotelRoomContract $contracts = null, \ArrayType\ArrayOfJP_Feature $features = null, $units = null, $source = null, $availRooms = null, $code = null, $jRCode = null, $combinationCode = null)
    {
        $this
            ->setName($name)
            ->setDescription($description)
            ->setRoomCategory($roomCategory)
            ->setRoomOccupancy($roomOccupancy)
            ->setRate($rate)
            ->setImages($images)
            ->setSize($size)
            ->setContracts($contracts)
            ->setFeatures($features)
            ->setUnits($units)
            ->setSource($source)
            ->setAvailRooms($availRooms)
            ->setCode($code)
            ->setJRCode($jRCode)
            ->setCombinationCode($combinationCode);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_HotelRoom
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\JP_HotelRoom
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get RoomCategory value
     * @return \StructType\JP_RoomCategory|null
     */
    public function getRoomCategory()
    {
        return $this->RoomCategory;
    }
    /**
     * Set RoomCategory value
     * @param \StructType\JP_RoomCategory $roomCategory
     * @return \StructType\JP_HotelRoom
     */
    public function setRoomCategory(\StructType\JP_RoomCategory $roomCategory = null)
    {
        $this->RoomCategory = $roomCategory;
        return $this;
    }
    /**
     * Get RoomOccupancy value
     * @return \StructType\JP_RoomOccupancy|null
     */
    public function getRoomOccupancy()
    {
        return $this->RoomOccupancy;
    }
    /**
     * Set RoomOccupancy value
     * @param \StructType\JP_RoomOccupancy $roomOccupancy
     * @return \StructType\JP_HotelRoom
     */
    public function setRoomOccupancy(\StructType\JP_RoomOccupancy $roomOccupancy = null)
    {
        $this->RoomOccupancy = $roomOccupancy;
        return $this;
    }
    /**
     * Get Rate value
     * @return \StructType\JP_Rate|null
     */
    public function getRate()
    {
        return $this->Rate;
    }
    /**
     * Set Rate value
     * @param \StructType\JP_Rate $rate
     * @return \StructType\JP_HotelRoom
     */
    public function setRate(\StructType\JP_Rate $rate = null)
    {
        $this->Rate = $rate;
        return $this;
    }
    /**
     * Get Images value
     * @return \ArrayType\ArrayOfJP_ImageLong|null
     */
    public function getImages()
    {
        return $this->Images;
    }
    /**
     * Set Images value
     * @param \ArrayType\ArrayOfJP_ImageLong $images
     * @return \StructType\JP_HotelRoom
     */
    public function setImages(\ArrayType\ArrayOfJP_ImageLong $images = null)
    {
        $this->Images = $images;
        return $this;
    }
    /**
     * Get Size value
     * @return \StructType\JP_HotelRoomSize|null
     */
    public function getSize()
    {
        return $this->Size;
    }
    /**
     * Set Size value
     * @param \StructType\JP_HotelRoomSize $size
     * @return \StructType\JP_HotelRoom
     */
    public function setSize(\StructType\JP_HotelRoomSize $size = null)
    {
        $this->Size = $size;
        return $this;
    }
    /**
     * Get Contracts value
     * @return \ArrayType\ArrayOfJP_HotelRoomContract|null
     */
    public function getContracts()
    {
        return $this->Contracts;
    }
    /**
     * Set Contracts value
     * @param \ArrayType\ArrayOfJP_HotelRoomContract $contracts
     * @return \StructType\JP_HotelRoom
     */
    public function setContracts(\ArrayType\ArrayOfJP_HotelRoomContract $contracts = null)
    {
        $this->Contracts = $contracts;
        return $this;
    }
    /**
     * Get Features value
     * @return \ArrayType\ArrayOfJP_Feature|null
     */
    public function getFeatures()
    {
        return $this->Features;
    }
    /**
     * Set Features value
     * @param \ArrayType\ArrayOfJP_Feature $features
     * @return \StructType\JP_HotelRoom
     */
    public function setFeatures(\ArrayType\ArrayOfJP_Feature $features = null)
    {
        $this->Features = $features;
        return $this;
    }
    /**
     * Get Units value
     * @return int|null
     */
    public function getUnits()
    {
        return $this->Units;
    }
    /**
     * Set Units value
     * @param int $units
     * @return \StructType\JP_HotelRoom
     */
    public function setUnits($units = null)
    {
        // validation for constraint: int
        if (!is_null($units) && !(is_int($units) || ctype_digit($units))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($units, true), gettype($units)), __LINE__);
        }
        $this->Units = $units;
        return $this;
    }
    /**
     * Get Source value
     * @return string|null
     */
    public function getSource()
    {
        return $this->Source;
    }
    /**
     * Set Source value
     * @param string $source
     * @return \StructType\JP_HotelRoom
     */
    public function setSource($source = null)
    {
        // validation for constraint: string
        if (!is_null($source) && !is_string($source)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($source, true), gettype($source)), __LINE__);
        }
        $this->Source = $source;
        return $this;
    }
    /**
     * Get AvailRooms value
     * @return int|null
     */
    public function getAvailRooms()
    {
        return $this->AvailRooms;
    }
    /**
     * Set AvailRooms value
     * @param int $availRooms
     * @return \StructType\JP_HotelRoom
     */
    public function setAvailRooms($availRooms = null)
    {
        // validation for constraint: int
        if (!is_null($availRooms) && !(is_int($availRooms) || ctype_digit($availRooms))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($availRooms, true), gettype($availRooms)), __LINE__);
        }
        $this->AvailRooms = $availRooms;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\JP_HotelRoom
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get JRCode value
     * @return string|null
     */
    public function getJRCode()
    {
        return $this->JRCode;
    }
    /**
     * Set JRCode value
     * @param string $jRCode
     * @return \StructType\JP_HotelRoom
     */
    public function setJRCode($jRCode = null)
    {
        // validation for constraint: string
        if (!is_null($jRCode) && !is_string($jRCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($jRCode, true), gettype($jRCode)), __LINE__);
        }
        $this->JRCode = $jRCode;
        return $this;
    }
    /**
     * Get CombinationCode value
     * @return string|null
     */
    public function getCombinationCode()
    {
        return $this->CombinationCode;
    }
    /**
     * Set CombinationCode value
     * @param string $combinationCode
     * @return \StructType\JP_HotelRoom
     */
    public function setCombinationCode($combinationCode = null)
    {
        // validation for constraint: string
        if (!is_null($combinationCode) && !is_string($combinationCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($combinationCode, true), gettype($combinationCode)), __LINE__);
        }
        $this->CombinationCode = $combinationCode;
        return $this;
    }
}
